
#include "param.h"
#include "socket.h"
#include "protosw.h"
#include "domain.h"
#include "mbuf.h"

int ax_init();
extern struct domain ax25domain;

int ax_output(), ax_drain();
int lapb_input(), lapb_usrreq(), lapb_ctloutput(), lapb_slowtimo();
int beacon_input(), beacon_usrreq(), beacon_ctloutput();
int axraw_input(), axraw_usrreq(), axraw_output(), axraw_ctloutput();

struct protosw ax25sw[] = {
{
	0,				&ax25domain,	0,				0,
	0,				ax_output,		0,				0,
	0,
	0,				0,				0,				ax_drain,
},
{
	SOCK_DGRAM,		&ax25domain,	0xf0,			PR_ATOMIC|PR_ADDR,
	beacon_input,	0,				0,				beacon_ctloutput,
	beacon_usrreq,
	0,				0,				0,				0,
},
{
	SOCK_STREAM,	&ax25domain,	0xf0,			PR_CONNREQUIRED|PR_WANTRCVD,
	lapb_input,		0,				0,				lapb_ctloutput,
	lapb_usrreq,
	0,				0,				lapb_slowtimo,	0,
},
{
	SOCK_RAW,		&ax25domain,	0,				PR_ATOMIC|PR_ADDR,
	axraw_input,	axraw_output,	0,				axraw_ctloutput,
	axraw_usrreq,
	0,				0,				0,				0,
},
};

struct domain ax25domain = {
	AF_AX25, "ax25", ax_init, 0, 0,
	ax25sw, &ax25sw[sizeof(ax25sw)/sizeof(ax25sw[0])]
};

