
; N81 software uart, rx only
; IC2 detects and times bits
;
; speedbuffer does dirty tricks with alignment and self-modification

	include regs.inc

IC2_V     equ 84h

IC2F      equ 02h
IC2edges  equ 0Ch

	;------------------------------------------------------------
	section .bsspgs    ; only for 'align 8' variables

	global _bbuart_buf, _bbuart_cnt

_bbuart_buf ds.b 256

	section .bankf
	align 1

state      ds.b 1
rx_shifter ds.b 1
prevtic    ds.w 1
bittime    ds.w 1
bittime1_5 ds.w 1

	;------------------------------------------------------------
	section .inthand
	align 1

	;------------------------------------------------------------

IC2_int

	pshm d,x,k
	ldab # FF
	tbek

	ldab PORTGP
	rorb
	andb # 1
	stab bitsense          ; 0 or 1 wrt the bit that has just started

	bclr TFLG1, # IC2F

	ldd  TIC2
	subd prevtic

	cpd  bittime_4
	bhi  L1
L1

	ldd  TIC2
	std  prevtic

	pulm d,x,k
	rti


	ldd  # 8000h           ; A=marker B=segment
	staa rx_shifter        ; prime with fresh marker, segment F XXX
	tbek                   ; switch EXT

	ldd  # IC4_OC5_int_databits
	std  IC4_OC5_V


	ldab PORTGP            ; sample rx bit XXX can be delayed too much
	andb # 02h
	rorb
	rorb
	ldaa rx_shifter        ; previous bits, segment F variable
	rora                   ; another bit in byte
	bcs  rx_did_byte       ; if have all of them now
	staa rx_shifter        ; re-shelve

	pulm d,k
	rti

rx_did_byte

	clrb                   ; RAM
	tbek                   ; switch EK

_bbuart_cnt equ * + 3      ; LSByte in the following 'staa ext'

	staa _bbuart_buf       ; self-mofifying silly trickstery
	inc  _bbuart_cnt       ; modify the address, wrap after 256 bytes

	ldd  # IC4_OC5_int_startbit
	std  IC4_OC5_V

	pulm d,k
	rti

	;------------------------------------------------------------
	section .text
	align 1

	global _bbuart_init

_bbuart_init               ; void _bbuart_init(word baud)

	xgex
	lde  # 1048576 / 65536 ; 16.777 MHz / 16 / baud
	ldd  # 1048576 % 65536
	ediv
	xgex                   ; time constant in E

	pshm k,ccr
	orp  # 000E0h          ; IPL 7

	ldd  # IC2_int
	std  IC2_V

	ldab # FF
	tbek                   ; switch EXT

	ste  bittime           ; one bit
	lsre                   ; half
	adde bittime           ; one and a half
	ste  bittime1_5        ; here.

	ldab # -1
	stab state

	bclr DDRGP, # IC2F     ; input

	bset TCTL2, # IC2edges ; 11 = both edges interrupts
	bclr TFLG1, # IC2F     ; forget stale capture
	bset TMSK1, # IC2F     ; enable IC2 interrupt

	pulm k,ccr             ; restore IPL
	rts

