
	global _enc_base91, _dec_base91

	section .text
	align 1

_enc_base91           ; void enc_base91(byte *p, dword *bin);

	xgey              ; p in IY
	xgdx              ; bin
	lde  0,x
	ldd  2,x          ; *bin in ED

	ldx  # 91 * 91
	ediv              ; ED / IX to IX, remainder to D
	xgex              ; save MSpart in E
	bsr  L0           ; do LSpart
	aiy  #-2          ; offset 'p' to MSpart bytes
	xgde              ; do MSpart from E
L0
	ldx  # 91
	idiv              ; D / IX to IX, remainder to D
	addb # '!'
	stab 3,y
	xgdx
	addb # '!'
	stab 2,y
	rts

_dec_base91           ; bool dec_base91(byte *p, dword *bin);

	xgey              ; p in IY
	xgdx              ; bin in IX

	ldd  0,y          ; p[0] and p[1]
	subd # '!!'
	cmpa # 91
	bcc  bad          ; outside allowed range
	cmpb # 91
	bcc  bad

	tde

	ldd  2,y          ; p[2] and p[3]
	subd # '!!'
	cmpa # 91
	bcc  bad
	cmpb # 91
	bcc  bad

	stab 3,x          ; tmp save, lowest
	ldab # 91
	mul               ; D = A * B
	addb 3,x
	adca # 0

	std  2,x          ; tmp save, two lowest
	ted

	stab 1,x          ; tmp save, second highest
	ldab # 91
	mul               ; D = A * B
	addb 1,x
	adca # 0

	lde  # 91 * 91
	emul              ; ED = E * D
	addd 2,x
	adce # 0          ; binary result

	ste  0,x
	std  2,x          ; in place

	ldd  # 1
	rts               ; TRUE
bad
	clrd	
	rts               ; FALSE

